"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("../helpers/utils");
const pupeteer = __importStar(require("puppeteer"));
const path_1 = __importDefault(require("path"));
const process_1 = __importDefault(require("process"));
const fs_1 = require("fs");
const os_1 = __importDefault(require("os"));
const extensionID_1 = require("../constants/extensionID");
class PuppeteerBrowser {
    constructor(pages, jsPath, disableRefresh) {
        if (typeof pages[0] === 'undefined') {
            throw new Error('Cannot be called directly');
        }
        else {
            this.pages = pages;
            this.jsPath = jsPath;
            this.disableRefresh = disableRefresh;
        }
    }
    ;
    static build({ urls, bundlePath, extensionsPath, credentials = null, disableRefresh = false, waitUntil = "load", disableExtensions = false }) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                if (this.instance)
                    return this.instance;
                const pathToChrome = (0, utils_1.getPathToChrome)();
                // const pathToChrome = pupeteer.executablePath();
                const jsPath = bundlePath || path_1.default.resolve(process_1.default.cwd() + "/dist/bundle.js");
                if (!pathToChrome || !(0, utils_1.existsSyncLocal)(pathToChrome)) {
                    throw new Error('Chrome was not found. Chrome must be installed for this extension to function. If you have Chrome installed at a custom location you can specify it in the \'chromePath\' setting.');
                }
                else if (!(0, utils_1.existsSyncLocal)(jsPath)) {
                    console.warn("!!!", jsPath);
                    throw new Error("No viable bundle.js");
                }
                ;
                let arg1 = `--disable-extensions-except=`;
                let arg2 = `--load-extension=`;
                const osType = os_1.default.type().toLocaleLowerCase();
                const homeDir = os_1.default.homedir();
                // const extensionsDir = path.resolve(`${homeDir}/Library/Application Support/Google/Chrome/Profile 3/Extensions`);
                const extensionsDir = extensionsPath ? path_1.default.resolve(homeDir + extensionsPath) : path_1.default.resolve(homeDir + "/Library/Application Support/Google/Chrome/Default/Extensions");
                const extensionsID = [
                    extensionID_1.extensionID.AXE_ID,
                    extensionID_1.extensionID.OMNIBUG_ID,
                    extensionID_1.extensionID.HEADINGS_MAP_ID,
                ];
                if (!disableExtensions && !(0, fs_1.existsSync)(extensionsDir)) {
                    throw new Error("Incorrect extensions directory, please use extensionsPath in the config to point to the right directory ");
                }
                ;
                for (const id of extensionsID) {
                    const dir = path_1.default.resolve(`${extensionsDir}/${id}/`);
                    const extensionFolderExist = (0, fs_1.existsSync)(dir);
                    if (!extensionFolderExist) {
                        console.log(extensionID_1.extensionName.get(id), "does not exist on chrome");
                        break;
                    }
                    ;
                    const version = (0, utils_1.getDirectories)(dir);
                    const pathToExtension = path_1.default.resolve(`${dir}/${version}`);
                    arg1 = arg1 + `${pathToExtension},`;
                    arg2 = arg2 + `${pathToExtension},`;
                }
                if (osType === "darwin" && !disableExtensions) {
                    console.log("Running with extensions enabled...");
                }
                else if (disableExtensions) {
                    console.log("Running with extensions force disabled...");
                }
                else {
                    console.log("Running with extensions disabled...");
                }
                let browser = yield pupeteer.launch({
                    executablePath: pathToChrome,
                    headless: false,
                    devtools: true,
                    defaultViewport: null,
                    args: osType === "darwin" && !disableExtensions ? [
                        arg1,
                        arg2,
                        '--enable-automation',
                    ] : [],
                });
                //Event Listeners
                // browser.on("targetcreated", async (target: any) => {
                // 	const page: pupeteer.Page = await target.page();
                // 	if (page) { page.close(); };
                // });
                browser.on("disconnected", () => __awaiter(this, void 0, void 0, function* () {
                    process_1.default.exit();
                }));
                let pages = yield browser.pages();
                for (let i = 0; i < urls.length; i++) {
                    //Target first tab
                    let page = null;
                    page = pages[i];
                    if (i > 0)
                        page = yield browser.newPage();
                    if (credentials)
                        yield page.authenticate({ username: credentials.user, password: credentials.password });
                    yield page.goto(urls[i], { waitUntil: waitUntil, timeout: 0 });
                    pages = yield browser.pages();
                }
                this.instance = new PuppeteerBrowser(pages, jsPath, disableRefresh);
                return this.instance;
            }
            catch (err) {
                throw err;
            }
        });
    }
    ;
    start() {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.render();
        });
    }
    ;
    render() {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                //Read the file
                let bundleScript = yield (0, utils_1.readFile)(this.jsPath);
                for (const page of this.pages) {
                    yield page.$eval("head", (elem, scriptTxt, styleTxt) => {
                        let script = document.createElement("script");
                        let style = document.createElement("style");
                        style.id = "inject_style_id";
                        style.innerHTML = styleTxt;
                        script.id = "inject_script_id";
                        script.type = "text/javascript";
                        script.text = scriptTxt;
                        elem.appendChild(style);
                        elem.appendChild(script);
                    }, bundleScript, "");
                    yield page.$eval("head", () => console.log('%c $$$JS_INJECT: Changes are live', 'background: #222; color: #bada55'));
                }
            }
            catch (err) {
                throw err;
            }
        });
    }
    ;
    reloadTab() {
        return __awaiter(this, void 0, void 0, function* () {
            if (!this.disableRefresh) {
                for (let page of this.pages) {
                    yield page.reload({ waitUntil: 'load' });
                }
            }
            yield this.render();
        });
    }
    ;
    //Used in render to create network fetching scripts or links
    // public async createAsyncTag(tag: any, prop: string, block: string) {
    // 	await this.page.$eval("head", (elem: any) => {
    // 		for (let val of tag) {
    // 			let createdTag: any = document.createElement(block);
    // 			if (val.id) { createdTag.id = val.id; };
    // 			if (block === "link") {
    // 				createdTag.rel = "stylesheet";
    // 				createdTag.type = 'text/css';
    // 			} else if (block === "script") {
    // 				createdTag.type = "text/javascript";
    // 			}
    // 			createdTag[prop] = val[prop];
    // 			elem.appendChild(createdTag);
    // 		}
    // 	}, tag, prop, block);
    // 	if (tag[tag.length - 1].id) { await this.page.waitForSelector(`#${tag[tag.length - 1].id}`) };
    // };
    get getJsPath() {
        return this.jsPath;
    }
}
exports.default = PuppeteerBrowser;
